#include <stdio.h>
#include <pthread.h>

#include "__thread.hpp"

extern __thread pthread_t pod;
extern Encap encap;
extern Templ<pthread_t> templ;

extern "C" void *foo (void *)
{
    int j = 0;
    pthread_t id = pthread_self();
    pod = encap._id = id;
    templ.bind (id);
    printf ("thread %d (%06lx), %d (%06lx), %d (%06lx) starts\n",
	    pod, &pod, encap._id, &encap._id, templ(), &templ._t);
    fflush (stdout);
    for (int i = 0; i < 100 * 1000 * 1000; i++)
	j += i;
    printf ("thread %d (%06lx), %d (%06lx), %d (%06lx) ends\n",
	    pod, &pod, encap._id, &encap._id, templ(), &templ._t);
    fflush (stdout);
    return NULL;
}
